//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_ADXL343_H
#define ULM_WEATHERBALLOON_ULM_ADXL343_H


#include "Adafruit_ADXL343.h"
#include "Ulm_GenericSensor.h"

struct Ulm_ADXL343_Sample {
    float accelerationX;    // Unit: m^2/s
    float accelerationY;    // Unit: m^2/s
    float accelerationZ;    // Unit: m^2/s
};

class Ulm_ADXL343 : public Adafruit_ADXL343, public Ulm_GenericSensor<struct Ulm_ADXL343_Sample> {

public:
    /**
     * Constructor.
     * @param address the i2c address of the ADXL343 sensor.
     * @param wire the i2c interface.
     */
    explicit Ulm_ADXL343(int32_t sensorId = 343, TwoWire *wireBus = &Wire);

    /**
     * Inits the sensor.
     * @return {@code true} on success, {@code false} otherwise.
     */
    bool begin() override;

    bool sample(struct Ulm_ADXL343_Sample &t) override;

};


#endif //ULM_WEATHERBALLOON_ULM_ADXL343_H
