//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_AS7331_H
#define ULM_WEATHERBALLOON_ULM_AS7331_H


#include "SparkFun_AS7331.h"
#include "Ulm_Beginnable.h"
#include "Ulm_GenericSensor.h"

struct Ulm_AS7331_Sample {
    float temperature;
    float uva;
    float uvb;
    float uvc;
};

class Ulm_AS7331 : public SfeAS7331ArdI2C, public Ulm_GenericSensor<struct Ulm_AS7331_Sample> {

public:
    /**
     * Default constructor.
     */
    Ulm_AS7331();

    /**
     * Inits the sensor.
     * @return {@code true} on success, {@code false} otherwise.
     */
    bool begin() override;

    bool sample(struct Ulm_AS7331_Sample &t) override;
};


#endif //ULM_WEATHERBALLOON_ULM_AS7331_H
