//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#include "Ulm_CCS811.h"

Ulm_CCS811::Ulm_CCS811() : Adafruit_CCS811() {
    // Nothing more to do here.
}

bool Ulm_CCS811::begin() {

    if(!Adafruit_CCS811::begin(CCS811_ADDRESS, &Wire)) {
        return false;
    }

    // Wait until sensor is ready with a 10-second timeout.
    unsigned long startTime = millis();
    while (millis() - startTime < 10000) {
        if(this->available()) {
            return true;
        }
    }
    return false;
}

bool Ulm_CCS811::sample(struct Ulm_CCS811_Sample &sample) {
    const bool success = this->readData() == 0;

    sample.co2  = this->geteCO2();
    sample.tvoc = this->getTVOC();

    return success;
}
