//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#include "Ulm_ENS16X.h"

Ulm_ENS16X::Ulm_ENS16X(uint8_t address, TwoWire &wire) : ScioSense_ENS160(&wire, address) {
    // Nothing more to do here.
}

bool Ulm_ENS16X::begin() {
    return ScioSense_ENS160::begin(false) && this->available() && this->setMode(ENS160_OPMODE_STD);
}

bool Ulm_ENS16X::sample(struct Ulm_ENS16X_Sample &sample) {

    bool success = this->measure(false) && this->measureRaw(false);

    sample.tvoc     = this->getTVOC();
    sample.co2      = this->geteCO2();
    sample.aqi      = this->getAQI();
    sample.aqi500   = this->getAQI500();

    return success;
}
