//
// Created by Falko Alrik Schmidt on 09.03.24.
//

#include "Ulm_LSM6SDL.h"

Ulm_LSM6SDL::Ulm_LSM6SDL(uint8_t address) : i2cAddress(address) {
    // Nothing more to do here.
}

bool Ulm_LSM6SDL::begin() {
    if(LSM6DSL::init(calData{false}, this->i2cAddress) != 0) {
        return false;
    }
   return LSM6DSL::setAccelRange(2) == 0 && // Set g range to max of 2g
            LSM6DSL::setGyroRange(500) == 0;
}

bool Ulm_LSM6SDL::sample(struct Ulm_LSM6SDL_Sample &sample) {

    // Create needed objects to read out sensor
    AccelData accelData{};
    GyroData gyroData{};

    // Sample
    LSM6DSL::update();
    LSM6DSL::getAccel(&accelData);
    LSM6DSL::getGyro(&gyroData);

    // Wrap the read values into our sample struct
    sample.accelerationX = accelData.accelX;
    sample.accelerationY = accelData.accelY;
    sample.accelerationZ = accelData.accelZ;
    sample.gyroscopeX = gyroData.gyroX;
    sample.gyroscopeY = gyroData.gyroY;
    sample.gyroscopeZ = gyroData.gyroZ;
    sample.temperature = LSM6DSL::getTemp();

    return true;
}
