//
// Created by Falko Alrik Schmidt on 11.01.24.
//

#ifndef ULM_WEATHERBALLOON_ULM_SCD4X_H
#define ULM_WEATHERBALLOON_ULM_SCD4X_H


#include "SensirionI2CScd4x.h"
#include "Ulm_GenericSensor.h"

struct Ulm_SCD4X_Sample {
    uint16_t co2;
    float temperature;
    float humidity;
};


class Ulm_SCD4X : SensirionI2CScd4x, public Ulm_GenericSensor<struct Ulm_SCD4X_Sample> {

public:
    /**
      * Default constructor.
      */
    Ulm_SCD4X();

    /**
     * Initializes the sensor.
     * @return {@code true} on success, {@code false} otherwise.
     */
    bool begin() override;

    bool sample(struct Ulm_SCD4X_Sample &t) override;

};

#endif //ULM_WEATHERBALLOON_ULM_SCD4X_H
